VTK: vtkVRMenuWidget Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Static Protected Member Functions | Protected Attributes | List of all members
vtkVRMenuWidget Class Reference

3D widget to display a menu in VR More...

`#include <vtkVRMenuWidget.h>`

Inheritance diagram for vtkVRMenuWidget:
[legend]
Collaboration diagram for vtkVRMenuWidget:
[legend]

## Public Types
enum | WidgetStateType { Start = 0 , Active }
typedef WidgetStateType | _WidgetState
Public Types inherited from vtkAbstractWidget
typedef vtkInteractorObserver | Superclass
| Standard macros implementing standard VTK methods. More...
Public Types inherited from vtkInteractorObserver
typedef vtkObject | Superclass

## Public Member Functions
void | SetRepresentation (vtkVRMenuRepresentation *rep)
| Specify an instance of vtkWidgetRepresentation used to represent this widget in the scene. More...
void | CreateDefaultRepresentation () override
| Create the default widget representation if one is not set. More...
void | Show (vtkEventData *ed)
void | ShowSubMenu (vtkVRMenuWidget *)
virtual int | GetWidgetState ()
| Get the widget state. More...
void | PushFrontMenuItem (const char *name, const char *text, vtkCommand *cmd)
| Methods to add/remove items to the menu, called by the menu widget. More...
void | RenameMenuItem (const char *name, const char *text)
| Methods to add/remove items to the menu, called by the menu widget. More...
void | RemoveMenuItem (const char *name)
| Methods to add/remove items to the menu, called by the menu widget. More...
void | RemoveAllMenuItems ()
| Methods to add/remove items to the menu, called by the menu widget. More...
Public Member Functions inherited from vtkAbstractWidget
void | SetEnabled (int) override
| Methods for activating this widget. More...
vtkWidgetEventTranslator * | GetEventTranslator ()
| Get the event translator. More...
void | Render ()
| This method is called by subclasses when a render method is to be invoked on the vtkRenderWindowInteractor. More...
void | SetParent (vtkAbstractWidget *parent)
| Specifying a parent to this widget is used when creating composite widgets. More...
virtual vtkAbstractWidget * | GetParent ()
void | SetPriority (float) override
| Override the superclass method. More...
virtual void | SetProcessEvents (vtkTypeBool)
| Methods to change whether the widget responds to interaction. More...
virtual vtkTypeBool | GetProcessEvents ()
| Methods to change whether the widget responds to interaction. More...
virtual void | ProcessEventsOn ()
| Methods to change whether the widget responds to interaction. More...
virtual void | ProcessEventsOff ()
| Methods to change whether the widget responds to interaction. More...
vtkWidgetRepresentation * | GetRepresentation ()
| Return an instance of vtkWidgetRepresentation used to represent this widget in the scene. More...
virtual void | SetManagesCursor (vtkTypeBool)
| Turn on or off the management of the cursor. More...
virtual vtkTypeBool | GetManagesCursor ()
| Turn on or off the management of the cursor. More...
virtual void | ManagesCursorOn ()
| Turn on or off the management of the cursor. More...
virtual void | ManagesCursorOff ()
| Turn on or off the management of the cursor. More...
vtkAbstractWidget * | NewInstance () const
| Standard macros implementing standard VTK methods. More...
Public Member Functions inherited from vtkInteractorObserver
vtkInteractorObserver * | NewInstance () const
int | GetEnabled ()
void | EnabledOn ()
void | EnabledOff ()
void | On ()
void | Off ()
virtual void | OnChar ()
| Sets up the keypress-i event. More...
virtual void | SetInteractor (vtkRenderWindowInteractor *iren)
| This method is used to associate the widget with the render window interactor. More...
virtual vtkRenderWindowInteractor * | GetInteractor ()
| This method is used to associate the widget with the render window interactor. More...
virtual float | GetPriority ()
| Set/Get the priority at which events are processed. More...
virtual void | PickingManagedOn ()
| Enable/Disable the use of a manager to process the picking. More...
virtual void | PickingManagedOff ()
| Enable/Disable the use of a manager to process the picking. More...
virtual void | SetPickingManaged (bool managed)
| Enable/Disable the use of a manager to process the picking. More...
virtual bool | GetPickingManaged ()
| Enable/Disable the use of a manager to process the picking. More...
virtual void | SetKeyPressActivation (vtkTypeBool)
| Enable/Disable of the use of a keypress to turn on and off the interactor observer. More...
virtual vtkTypeBool | GetKeyPressActivation ()
| Enable/Disable of the use of a keypress to turn on and off the interactor observer. More...
virtual void | KeyPressActivationOn ()
| Enable/Disable of the use of a keypress to turn on and off the interactor observer. More...
virtual void | KeyPressActivationOff ()
| Enable/Disable of the use of a keypress to turn on and off the interactor observer. More...
virtual void | SetKeyPressActivationValue (char)
| Specify which key press value to use to activate the interactor observer (if key press activation is enabled). More...
virtual char | GetKeyPressActivationValue ()
| Specify which key press value to use to activate the interactor observer (if key press activation is enabled). More...
virtual vtkRenderer * | GetDefaultRenderer ()
| Set/Get the default renderer to use when activating the interactor observer. More...
virtual void | SetDefaultRenderer (vtkRenderer *)
| Set/Get the default renderer to use when activating the interactor observer. More...
virtual vtkRenderer * | GetCurrentRenderer ()
| Set/Get the current renderer. More...
virtual void | SetCurrentRenderer (vtkRenderer *)
| Set/Get the current renderer. More...
void | GrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods enable an interactor observer to exclusively grab all events invoked by its associated vtkRenderWindowInteractor. More...
void | ReleaseFocus ()
| These methods enable an interactor observer to exclusively grab all events invoked by its associated vtkRenderWindowInteractor. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkVRMenuWidget * | New ()
| Instantiate the object. More...
Static Public Member Functions inherited from vtkAbstractWidget
static vtkTypeBool | IsTypeOf (const char *type)
| Standard macros implementing standard VTK methods. More...
static vtkAbstractWidget * | SafeDownCast (vtkObjectBase *o)
| Standard macros implementing standard VTK methods. More...
Static Public Member Functions inherited from vtkInteractorObserver
static vtkTypeBool | IsTypeOf (const char *type)
static vtkInteractorObserver * | SafeDownCast (vtkObjectBase *o)
static void | ComputeDisplayToWorld (vtkRenderer *ren, double x, double y, double z, double worldPt[4])
| Convenience methods for outside classes. More...
static void | ComputeWorldToDisplay (vtkRenderer *ren, double x, double y, double z, double displayPt[3])
| Convenience methods for outside classes. More...
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
| vtkVRMenuWidget ()
| ~vtkVRMenuWidget () override
Protected Member Functions inherited from vtkAbstractWidget
| vtkAbstractWidget ()
| ~vtkAbstractWidget () override
void | SetWidgetRepresentation (vtkWidgetRepresentation *r)
virtual void | SetCursor (int vtkNotUsed(state))
Protected Member Functions inherited from vtkInteractorObserver
| vtkInteractorObserver ()
| ~vtkInteractorObserver () override
virtual void | RegisterPickers ()
| Register internal Pickers in the Picking Manager. More...
void | UnRegisterPickers ()
| Unregister internal pickers from the Picking Manager. More...
vtkPickingManager * | GetPickingManager ()
| Return the picking manager associated on the context on which the observer currently belong. More...
vtkAssemblyPath * | GetAssemblyPath (double X, double Y, double Z, vtkAbstractPropPicker *picker)
| Proceed to a pick, whether through the PickingManager if the picking is managed or directly using the picker, and return the assembly path. More...
int | RequestCursorShape (int requestedShape)
virtual void | StartInteraction ()
| Utility routines used to start and end interaction. More...
virtual void | EndInteraction ()
| Utility routines used to start and end interaction. More...
void | ComputeDisplayToWorld (double x, double y, double z, double worldPt[4])
| Helper method for subclasses. More...
void | ComputeWorldToDisplay (double x, double y, double z, double displayPt[3])
| Helper method for subclasses. More...
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Static Protected Member Functions
static void | StartMenuAction (vtkAbstractWidget *)
static void | SelectMenuAction (vtkAbstractWidget *)
static void | MoveAction (vtkAbstractWidget *)
static void | EventCallback (vtkObject *object, unsigned long event, void *clientdata, void *calldata)
static void | Update (vtkAbstractWidget *)
| Update callback to check for the hovered prop. More...
Static Protected Member Functions inherited from vtkAbstractWidget
static void | ProcessEventsHandler (vtkObject *object, unsigned long event, void *clientdata, void *calldata)
Static Protected Member Functions inherited from vtkInteractorObserver
static void | ProcessEvents (vtkObject *object, unsigned long event, void *clientdata, void *calldata)
| Handles the char widget activation event. More...
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Protected Attributes
int | WidgetState
std::deque< InternalElement * > | Menus
vtkCallbackCommand * | EventCommand
Protected Attributes inherited from vtkAbstractWidget
vtkWidgetRepresentation * | WidgetRep
vtkTypeBool | ManagesCursor
vtkWidgetEventTranslator * | EventTranslator
vtkWidgetCallbackMapper * | CallbackMapper
vtkAbstractWidget * | Parent
void * | CallData
vtkTypeBool | ProcessEvents
int | LastDevice
Protected Attributes inherited from vtkInteractorObserver
int | Enabled
vtkCallbackCommand * | EventCallbackCommand
vtkCallbackCommand * | KeyPressCallbackCommand
float | Priority
bool | PickingManaged
vtkTypeBool | KeyPressActivation
char | KeyPressActivationValue
vtkRenderWindowInteractor * | Interactor
vtkRenderer * | CurrentRenderer
vtkRenderer * | DefaultRenderer
unsigned long | CharObserverTag
unsigned long | DeleteObserverTag
vtkObserverMediator * | ObserverMediator
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers
typedef vtkAbstractWidget | Superclass
| Standard vtkObject methods. More...
static vtkTypeBool | IsTypeOf (const char *type)
| Standard vtkObject methods. More...
static vtkVRMenuWidget * | SafeDownCast (vtkObjectBase *o)
| Standard vtkObject methods. More...
virtual vtkTypeBool | IsA (const char *type)
| Standard vtkObject methods. More...
vtkVRMenuWidget * | NewInstance () const
| Standard vtkObject methods. More...
void | PrintSelf (ostream &os, vtkIndent indent) override
| Standard vtkObject methods. More...
virtual vtkObjectBase * | NewInstanceInternal () const
| Standard vtkObject methods. More...

## Detailed Description

3D widget to display a menu in VR

See also
  vtkVRMenuRepresentation

Definition at line 23 of file vtkVRMenuWidget.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkAbstractWidget vtkVRMenuWidget::Superclass

Standard vtkObject methods.

Definition at line 35 of file vtkVRMenuWidget.h.

## ◆ _WidgetState

typedef WidgetStateType vtkVRMenuWidget::_WidgetState

Definition at line 66 of file vtkVRMenuWidget.h.

## Member Enumeration Documentation

## ◆ WidgetStateType

enum vtkVRMenuWidget::WidgetStateType

Enumerator
Start |
Active |

Definition at line 59 of file vtkVRMenuWidget.h.

## Constructor & Destructor Documentation

## ◆ vtkVRMenuWidget()

vtkVRMenuWidget::vtkVRMenuWidget | ( |  | ) |
| protected

## ◆ ~vtkVRMenuWidget()

vtkVRMenuWidget::~vtkVRMenuWidget | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ New()

static vtkVRMenuWidget* vtkVRMenuWidget::New | ( |  | ) |
| static

Instantiate the object.

## ◆ IsTypeOf()

static vtkTypeBool vtkVRMenuWidget::IsTypeOf | ( | const char * | type | ) |
| static

Standard vtkObject methods.

## ◆ IsA()

virtual vtkTypeBool vtkVRMenuWidget::IsA | ( | const char * | type | ) |
| virtual

Standard vtkObject methods.

Reimplemented from vtkAbstractWidget.

## ◆ SafeDownCast()

static vtkVRMenuWidget* vtkVRMenuWidget::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

Standard vtkObject methods.

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkVRMenuWidget::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Standard vtkObject methods.

Reimplemented from vtkAbstractWidget.

## ◆ NewInstance()

vtkVRMenuWidget* vtkVRMenuWidget::NewInstance | ( |  | ) | const

Standard vtkObject methods.

## ◆ PrintSelf()

void vtkVRMenuWidget::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Standard vtkObject methods.

Reimplemented from vtkAbstractWidget.

## ◆ SetRepresentation()

void vtkVRMenuWidget::SetRepresentation | ( | vtkVRMenuRepresentation * | rep | ) |

Specify an instance of vtkWidgetRepresentation used to represent this widget in the scene.

Note that the representation is a subclass of vtkProp so it can be added to the renderer independent of the widget.

## ◆ CreateDefaultRepresentation()

void vtkVRMenuWidget::CreateDefaultRepresentation | ( |  | ) |
| overridevirtual

Create the default widget representation if one is not set.

Implements vtkAbstractWidget.

## ◆ GetWidgetState()

virtual int vtkVRMenuWidget::GetWidgetState | ( |  | ) |
| virtual

Get the widget state.

## ◆ PushFrontMenuItem()

void vtkVRMenuWidget::PushFrontMenuItem | ( | const char * | name,
|  | const char * | text,
|  | vtkCommand * | cmd
| ) |  |

Methods to add/remove items to the menu, called by the menu widget.

## ◆ RenameMenuItem()

void vtkVRMenuWidget::RenameMenuItem | ( | const char * | name,
|  | const char * | text
| ) |  |

Methods to add/remove items to the menu, called by the menu widget.

## ◆ RemoveMenuItem()

void vtkVRMenuWidget::RemoveMenuItem | ( | const char * | name | ) |

Methods to add/remove items to the menu, called by the menu widget.

## ◆ RemoveAllMenuItems()

void vtkVRMenuWidget::RemoveAllMenuItems | ( |  | ) |

Methods to add/remove items to the menu, called by the menu widget.

## ◆ Show()

void vtkVRMenuWidget::Show | ( | vtkEventData * | ed | ) |

## ◆ ShowSubMenu()

void vtkVRMenuWidget::ShowSubMenu | ( | vtkVRMenuWidget * |  | ) |

## ◆ StartMenuAction()

static void vtkVRMenuWidget::StartMenuAction | ( | vtkAbstractWidget * |  | ) |
| staticprotected

## ◆ SelectMenuAction()

static void vtkVRMenuWidget::SelectMenuAction | ( | vtkAbstractWidget * |  | ) |
| staticprotected

## ◆ MoveAction()

static void vtkVRMenuWidget::MoveAction | ( | vtkAbstractWidget * |  | ) |
| staticprotected

## ◆ EventCallback()

static void vtkVRMenuWidget::EventCallback | ( | vtkObject * | object,
|  | unsigned long | event,
|  | void * | clientdata,
|  | void * | calldata
| ) |  |
| staticprotected

## ◆ Update()

static void vtkVRMenuWidget::Update | ( | vtkAbstractWidget * |  | ) |
| staticprotected

Update callback to check for the hovered prop.

## Member Data Documentation

## ◆ WidgetState

int vtkVRMenuWidget::WidgetState
| protected

Definition at line 86 of file vtkVRMenuWidget.h.

## ◆ Menus

std::deque<InternalElement*> vtkVRMenuWidget::Menus
| protected

Definition at line 89 of file vtkVRMenuWidget.h.

## ◆ EventCommand

vtkCallbackCommand* vtkVRMenuWidget::EventCommand
| protected

Definition at line 96 of file vtkVRMenuWidget.h.

The documentation for this class was generated from the following file:

- Rendering/VR/vtkVRMenuWidget.h